patch-packages: Disable mechanism once again
[fuel.git] / build / install / install.sh
1 #!/bin/bash -e
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # stefan.k.berg@ericsson.com
5 # jonas.bjurel@ericsson.com
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Apache License, Version 2.0
8 # which accompanies this distribution, and is available at
9 # http://www.apache.org/licenses/LICENSE-2.0
10 ##############################################################################
11
12
13 my_exit() {
14     rc=$?
15
16     cd /tmp
17
18     if [ -n "$TMP_HOSTMOUNT" ]; then
19         if [ -d "$TMP_HOSTMOUNT" ]; then
20             fusermount -u $TMP_HOSTMOUNT
21             rmdir $TMP_HOSTMOUNT
22         fi
23     fi
24
25     if [ -d "$TMP_OLDISO" ]; then
26         fusermount -u $TMP_OLDISO
27         rmdir $TMP_OLDISO
28     fi
29
30     if [ -f "$CONF" ]; then
31         rm $CONF
32     fi
33
34     if [ -d "$TMP_ISOPUPPET" ]; then
35         rm -Rf $TMP_ISOPUPPET
36     fi
37 }
38
39 get_deb_name() {
40     ar p $1 control.tar.gz | tar xzO ./control | grep "^Package:.* " | sed 's/.* //'
41     if [ $PIPESTATUS -ne 0 ]; then
42         echo "Error in get_deb_name($1)"
43         exit 1
44     fi
45 }
46
47 get_deb_rev() {
48     ar p $1 control.tar.gz | tar xzO ./control | grep "^Version:.* " | sed 's/.* //'
49     if [ $PIPESTATUS -ne 0 ]; then
50         echo "Error in get_deb_rev($1)"
51         exit 1
52     fi
53 }
54
55
56 # Added logic for ".orig" files:
57 #   1. Is there an .orig file for the new file?
58 #   2. If the file is not present in base ISO -> Error!
59 #   3. If the file is changed i base ISO -> Error!  (need manual rebase)
60 #   4. If there is no .orig file, but file is present in base ISO: Error!
61 verify_orig_files() {
62     OLDDIR=$1
63     NEWDIR=$2
64
65     pushd $NEWDIR >/dev/null
66     for f in $(find * -type f -name '*.orig')
67     do
68         origfile=$NEWDIR/$f
69         oldfile=$OLDDIR/$(echo $f | sed 's/.orig$//')
70         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
71
72         origfile=${newfile}.orig
73         # If no corresponding base file, error
74         if [ ! -f $oldfile ]; then
75             printf "\n\n\n\n"
76             echo "Error: found ${newfile} but no"
77             echo "Error: ${oldfile}"
78             echo "Error: Manual rebase is needed!"
79             printf "\n\n\n\n"
80             exit 1
81         fi
82
83         # If orig file differs from base file, error
84         if ! diff -q $origfile $oldfile > /dev/null; then
85             printf "\n\n\n\n"
86             echo "Error: $origfile differs from"
87             echo "Error: $oldfile!"
88             echo "Error: Manual rebase is needed!"
89             printf "\n\n\n\n"
90             exit 1
91         fi
92
93     done
94
95
96     # Check that there we're not overwriting oldfiles without having a ".orig" copy
97     for f in $(find * -type f ! -name '*.orig')
98     do
99         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
100         origfile=${newfile}.orig
101         oldfile=$OLDDIR/$f
102         if [ -f $oldfile ]; then
103             if [ ! -f $origfile ]; then
104                 printf "\n\n\n\n"
105                 echo "Error: Will overwrite $oldfile, but there is no"
106                 echo "Error: $origfile!"
107                 echo "Error: You need to create the `basename $origfile`!"
108                 printf "\n\n\n\n"
109                 exit 1
110             fi
111         fi
112     done
113
114
115     popd >/dev/null
116 }
117
118 prep_make_live() {
119     DEST=$TMP_HOSTMOUNT
120     REPO=$DEST/var/www/nailgun/ubuntu/fuelweb/x86_64
121     echo "Live install"
122     ssh-copy-id root@$FUELHOST
123     sshfs root@1${FUELHOST}:/ $TMP_HOSTMOUNT
124
125     if [ -f  $REPO/dists/xenial/main/binary-amd64/Packages.backup ]; then
126         echo "Error - found backup file for Packages!"
127         exit 1
128     fi
129
130     if [ -f  $REPO/dists/xenial/main/binary-amd64/Packages.gz.backup ]; then
131         echo "Error - found backup file for Packages.gz!"
132         exit 1
133     fi
134
135     if [ -f  $REPO/dists/xenial/Release.backup ]; then
136         echo "Error - found backup file for Release!"
137         exit 1
138     fi
139
140     if [ -d  $DEST/etc/puppet.backup ]; then
141         echo "Error - found backup file for Puppet!"
142         exit 1
143     fi
144
145     cp $REPO/dists/xenial/main/binary-amd64/Packages $REPO/dists/xenial/main/binary-amd64/Packages.backup
146     cp $REPO/dists/xenial/main/binary-amd64/Packages.gz $REPO/dists/xenial/main/binary-amd64/Packages.gz.backup
147     cp $REPO/dists/xenial/Release $REPO/dists/xenial/Release.backup
148     cp -Rvp $DEST/etc/puppet $DEST/etc/puppet.backup
149 }
150
151 post_make_live() {
152     if [ -d $TOP/release/puppet/modules ]; then
153         echo "Installing into Puppet:"
154         cd $TOP/release/puppet/modules
155         if [ `ls -1 | wc -l` -gt 0 ]; then
156             for dir in *
157             do
158                 echo "   $dir"
159                 cp -Rp $dir $DEST/etc/puppet/modules
160             done
161         fi
162     fi
163 }
164
165 make_live() {
166     prep_make_live
167     copy_packages
168     post_make_live
169 }
170
171
172 prep_make_iso() {
173     DEST=$TOP/newiso
174     REPO=$DEST/ubuntu
175     echo "Preparing ISO..."
176     echo "Unpack of old ISO..."
177     if [ -d newiso ]; then
178         chmod -R 755 newiso
179         rm -rf newiso
180     fi
181     mkdir newiso
182     fusermount -u $TMP_OLDISO 2>/dev/null || cat /dev/null
183     fuseiso -p $ORIGISO $TMP_OLDISO
184     sleep 1
185     cd $TMP_OLDISO
186     find . | cpio -pd $TOP/newiso
187     cd ..
188     fusermount -u $TMP_OLDISO
189     rm -Rf $TMP_OLDISO
190     chmod -R 755 $TOP/newiso
191 }
192
193 make_iso_image() {
194     echo "Making ISO..."
195     cd $DEST
196     find . -name TRANS.TBL -exec rm {} \;
197     rm -rf rr_moved
198
199     if [[ -z "$OPNFV_GIT_SHA" ]]; then
200         OPNFV_GIT_SHA=$(git rev-parse --verify HEAD)
201     fi
202
203     mkisofs --quiet -r -V "$VOLUMEID" -publisher "$PUBLISHER" \
204         -p "$OPNFV_GIT_SHA" -J -R -b isolinux/isolinux.bin \
205         -no-emul-boot \
206         -boot-load-size 4 -boot-info-table \
207         --hide-rr-moved \
208         --joliet-long \
209         -x "lost+found" -o $NEWISO .
210
211     isoinfo -d -i $NEWISO
212 }
213
214 # iso_copy_puppet: Create a new puppet-slave.tgz for the iso
215 iso_copy_puppet() {
216     echo "Installing into Puppet..."
217     mkdir -p $TMP_ISOPUPPET/release/puppet
218     cd $TMP_ISOPUPPET/release/puppet
219     tar xzf $DEST/puppet-slave.tgz
220     cd $TOP/release/puppet/modules
221
222     # Remove all .orig files before copying as they now have been verfied
223
224     if [ -d $TOP/release/puppet/modules ]; then
225         if [ `ls -1 | wc -l` -gt 0 ]; then
226             verify_orig_files $TMP_ISOPUPPET/release/puppet $TOP/release/puppet/modules
227             find $TOP/release/puppet/modules -type f -name '*.orig' -exec rm {} \;
228             for dir in $TOP/release/puppet/modules/*
229             do
230                 echo "   $dir"
231                 cp -Rp $dir $TMP_ISOPUPPET/release/puppet
232             done
233         fi
234     fi
235
236     cd $TMP_ISOPUPPET/release/puppet
237     tar czf $DEST/puppet-slave.tgz .
238     cd $TOP
239     rm -Rf $TMP_ISOPUPPET
240 }
241
242 # iso_modify_image: Add/patch files in the ISO root
243 iso_modify_image () {
244     # TODO: Add logic for ".orig" files (hey! make a function!), which would look
245     # something like:
246     #   1. Is there an .orig file?
247     #   2. If the file is not present in origiso -> Error exit
248     #   3. If the file is changed in origiso -> Error exit (need manual rebase)
249     #   4. Otherwise continue, but don't copy orig file (or maybe we should?)
250     # ... and corresponding reverse logic:
251     #   1. If there is no .orig file, but file is present in origiso -> Error exit
252     echo "Modify ISO files (wild copy)..."
253
254     verify_orig_files $DEST $TOP/release/isoroot
255     # Remove all .orig files before copying as they now have been verfied
256     find $TOP/release/isoroot -type f -name '*.orig' -exec rm {} \;
257
258     cd $TOP/release/isoroot
259     cp -Rvp . $DEST
260
261     # Add all Git info files
262     sort $TOP/gitinfo*.txt > $DEST/gitinfo.txt
263     cp $DEST/gitinfo.txt $REPORTFILE
264 }
265
266 make_iso() {
267     prep_make_iso
268     copy_packages
269     #iso_copy_puppet
270     iso_modify_image
271     make_iso_image
272 }
273
274 copy_packages() {
275     echo "Copying Debian packages..."
276     cd $TOP/release/packages/ubuntu/pool/debian-installer
277
278     for udeb in `ls -1 | grep '\.udeb$'`
279     do
280         echo "   $udeb"
281         cp $udeb $REPO/pool/debian-installer
282         echo "Did not expect a package here, not supported"
283         exit 1
284     done
285
286     cd $TOP/release/packages/ubuntu/pool/main
287     for deb in `ls -1 | grep '\.deb$'`
288     do
289         echo "   $deb"
290         cp $deb $REPO/pool/main
291         echo "Did not expect a package here, not supported"
292         exit 1
293     done
294
295     echo "Running Fuel package patch file"
296     pushd $REPO/pool/main > /dev/null
297
298     for line in `cat $TOP/apply_patches | grep -v "^#" | grep -v "^$"`; do
299         echo "Line is $line"
300         echo "Did not expect a line here, not supported"
301         exit 1
302         ref=`echo $line | cut -d '>' -f 1`
303         origpkg=`echo $line| cut -d '>' -f 2`
304         url=`echo $line | cut -d '>' -f 3`
305
306         if [ -z "$origpkg" ]; then
307             echo "Error: No origpkg for patching"
308             exit 1
309         fi
310
311         if [ -z "$url" ]; then
312             echo "Error: No url for patching"
313             exit 1
314         fi
315
316         if [ -z "$ref" ]; then
317             echo "Error: No reference text for patching"
318             exit 1
319         fi
320
321         echo "CM: Patching Fuel package for $ref" | tee -a $REPORTFILE
322         echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
323         oldrev=`get_deb_rev $origpkg`
324         rm $origpkg
325         wget --quiet $url
326         topkg=`basename $url`
327         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
328         md5sum $topkg | tee -a $REPORTFILE
329
330         patchname=`get_deb_name $topkg`
331         patchrev=`get_deb_rev $topkg`
332         echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
333         $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
334         if [ $PIPESTATUS -ne 0 ]; then
335             exit 1
336         fi
337     done
338
339     printf "Done running Fuel patch file\n\n"
340     echo "Running add packages file"
341     for line in `cat $TOP/add_opnfv_packages | grep -v "^#" | grep -v "^$"`; do
342         echo "Line is $line"
343         echo "Did not expect a line here, not supported"
344         exit 1
345         ref=`echo $line | cut -d '>' -f 1`
346         origpkg=`echo $line| cut -d '>' -f 2`
347         url=`echo $line | cut -d '>' -f 3`
348
349         if [ -z "$origpkg" ]; then
350             echo "Error: No origpkg for patching"
351             exit 1
352         fi
353
354         if [ -z "$url" ]; then
355             echo "Error: No url for patching"
356             exit 1
357         fi
358
359         if [ -z "$ref" ]; then
360             echo "Error: No reference text for patching"
361             exit 1
362         fi
363
364         if [ "$origpkg" != "NONE" ]; then
365             echo "CM: Patching added package for $ref" | tee -a $REPORTFILE
366             echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
367             oldrev=`get_deb_rev $origpkg`
368             rm $origpkg
369         else
370             echo "CM: Adding previoulsy uninstalled package for $ref" tee -a $REPORTFILE
371         fi
372         wget --quiet $url
373         topkg=`basename $url`
374         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
375         md5sum $topkg | tee -a $REPORTFILE
376         if [ "$origpkg" != "NONE" ]; then
377             patchname=`get_deb_name $topkg`
378             patchrev=`get_deb_rev $topkg`
379             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
380             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
381             if [ $PIPESTATUS -ne 0 ]; then
382                 exit 1
383             fi
384         fi
385     done
386     printf "Done running add packages file\n\n"
387
388     popd > /dev/null
389
390     if [ -f $TOP/patch-packages/release/patch-replacements ]; then
391         echo "Applying package patches" | tee -a $REPORTFILE
392         pushd $REPO/pool/main > /dev/null
393         echo "CM: I am now in $(pwd)"
394         printf "\n\n" | tee -a  $REPORTFILE
395         for line in `cat $TOP/patch-packages/release/patch-replacements`
396         do
397             echo "Did not expect a line here, not supported"
398             exit 1
399             echo "Processing $line ..."
400             frompkg=`echo $line | cut -d ">" -f 1`
401             topkg=`echo $line | cut -d ">" -f 2`
402             echo "CM: Applying patch to $frompkg" | tee -a $REPORTFILE
403             echo "CM: New package rev after patch: $topkg" | tee -a $REPORTFILE
404
405             if [ ! -f $frompkg ]; then
406                 echo "Error: Can't find $frompkg in repo"
407                 exit 1
408             else
409                 oldrev=`get_deb_rev $frompkg`
410                 echo "Removing $frompkg from repo"
411                 rm $frompkg
412             fi
413
414             if [ ! -f $TOP/patch-packages/release/packages/$topkg ]; then
415                 echo "Error: Can't find $topkg in patch release"
416                 exit 1
417             else
418                 echo "Adding $topkg to repo"
419                 pkg_dest=$(dirname $frompkg)
420                 cp $TOP/patch-packages/release/packages/$topkg $pkg_dest/
421             fi
422
423             pushd $pkg_dest > /dev/null
424             patchname=`get_deb_name $topkg`
425             patchrev=`get_deb_rev $topkg`
426             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
427             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
428             if [ $PIPESTATUS -ne 0 ]; then
429                 exit 1
430             fi
431             popd > /dev/null
432         done
433         popd > /dev/null
434     fi
435
436     echo "Generating metadata..."
437     pushd $REPO > /dev/null
438
439     # The below methods are from 15B
440     APT_REL_CONF="$TOP/install/apt-ftparchive-release.conf"
441     APT_DEB_CONF="$TOP/install/apt-ftparchive-deb.conf"
442     APT_UDEB_CONF="$TOP/install/apt-ftparchive-udeb.conf"
443
444     echo Not running apt-ftparchive -c "${APT_REL_CONF}" generate "${APT_DEB_CONF}"
445     echo Not running apt-ftparchive generate "${APT_UDEB_CONF}"
446
447     # Fuel also needs this index file
448     # cat dists/xenial/main/binary-amd64/Packages | \
449     #    awk '/^Package:/{pkg=$2}
450     # /^Version:/{print pkg ": \"" $2 "\""}' > ubuntu-versions.yaml
451     # cp ubuntu-versions.yaml $DEST
452
453     # apt-ftparchive -c "${APT_REL_CONF}" release dists/mos10.0/ > dists/mos10.0/Release
454     # gzip -9cf dists/mos10.0/Release > dists/mos10.0/Release.gz
455
456     popd > /dev/null
457
458 }
459
460
461 #############################################################################
462
463 trap my_exit EXIT
464
465 CONF=`mktemp /tmp/XXXXXXX`
466 MODE=$1
467 TOP=`pwd`
468
469 if [ $MODE = "iso" ]; then
470     PUBLISHER="OPNFV"
471     TMP_OLDISO=`mktemp -d /tmp/XXXXXXX`
472     TMP_ISOPUPPET=`mktemp -d /tmp/XXXXXXX`
473     ORIGISO=$2
474     NEWISO=$3
475     VOLUMEID="$4_$5"
476     REPORTFILE="${NEWISO}.txt"
477     echo "Opening reportfile at $REPORTFILE"
478     touch $REPORTFILE
479     if [ ! -f $ORIGISO ]; then
480         echo "Can't find original iso at $ORIGISO"
481         rm $CONF
482         exit 1
483     fi
484
485     make_iso
486 else
487     echo "Unknown mode: $MODE"
488     exit 1
489 fi